<?php

namespace FiloBlu\Design\Block\Plugin\Checkout;

use Magento\Checkout\Helper\Data;

class LayoutProcessor
{
    public $_helper;
    public $_checkoutHelper;

    public function __construct(\FiloBlu\Design\Helper\Data $helper, Data $checkoutHelper)
    {
        $this->_helper = $helper;
        $this->_checkoutHelper = $checkoutHelper;
    }

    public function afterProcess($subject, $jsLayout)
    {
        $_intlTelInput = $this->_helper->getConfig('js_library/intlTelInput_enabled') && $this->_helper->getConfig('js_library/intlTelInput_enableOnCheckout');

        if ($_intlTelInput) {
            if ($this->_checkoutHelper->isDisplayBillingOnPaymentMethodAvailable()) {
                $configuration = $jsLayout['components']['checkout']['children']['steps']['children']['billing-step']['children']['payment']['children']['payments-list']['children'];
                foreach ($configuration as $paymentGroup => $groupConfig) {
                    if (isset($groupConfig['component']) && $groupConfig['component'] === 'Magento_Checkout/js/view/billing-address') {
                        if (isset($jsLayout['components']['checkout']['children']['steps']['children']['billing-step']['children']
                                        ['payment']['children']['payments-list']['children'][$paymentGroup]['children']['form-fields']['children']['telephone'])) {
                            $jsLayout['components']['checkout']['children']['steps']['children']['billing-step']['children']
                                    ['payment']['children']['payments-list']['children'][$paymentGroup]['children']['form-fields']['children']['telephone']["component"] = "FiloBlu_Design/js/form/element/telephone";

                            $jsLayout['components']['checkout']['children']['steps']['children']['billing-step']['children']
                                    ['payment']['children']['payments-list']['children'][$paymentGroup]['children']['form-fields']['children']['telephone']["config"]["elementTmpl"] = "FiloBlu_Design/ui/form/element/telephone";
                        }
                    }
                }
            } else {
                if (isset($jsLayout['components']['checkout']['children']['steps']['children']['billing-step']['children']
                                ['payment']['children']['afterMethods']['children']['billing-address-form']['children']['form-fields']['children']['telephone'])) {
                    $jsLayout['components']['checkout']['children']['steps']['children']['billing-step']['children']
                            ['payment']['children']['afterMethods']['children']['billing-address-form']['children']['form-fields']['children']['telephone']["component"] = "FiloBlu_Design/js/form/element/telephone";

                    $jsLayout['components']['checkout']['children']['steps']['children']['billing-step']['children']
                            ['payment']['children']['afterMethods']['children']['billing-address-form']['children']['form-fields']['children']['telephone']["config"]["elementTmpl"] = "FiloBlu_Design/ui/form/element/telephone";
                }
            }
        }

        return $jsLayout;
    }
}
