<?php

namespace FiloBlu\Design\Model\Config\Source;

use Magento\Cms\Model\Block;
use Magento\Framework\Option\ArrayInterface;

/**
 * Class LinkType
 * @package FiloBlu\Design\Model\Config\Source
 */
class LinkType implements ArrayInterface
{
    protected $_blockModel;

    /**
     * @param Block $blockModel
     */
    public function __construct(
        Block $blockModel
    )
    {
        $this->_groupModel = $blockModel;
    }

    /**
     * Options getter
     *
     * @return array
     */
    public function toOptionArray()
    {
        $options = [
            ['label' => __('No Link'), 'value' => -1],
            ['label' => __('Custom'), 'value' => 4],
            ['label' => __('Category'), 'value' => 1],
            ['label' => __('Product'), 'value' => 2],
            ['label' => __('CMS Page'), 'value' => 3],

        ];
        array_unshift($options, array(
            'value' => '',
            'label' => '',
        ));
        return $options;
    }
}